t / test-lib-functions.shon commit Merge branch 'es/want-color-fd-defensive' (271940c)
   1# Library of functions shared by all tests scripts, included by
   2# test-lib.sh.
   3#
   4# Copyright (c) 2005 Junio C Hamano
   5#
   6# This program is free software: you can redistribute it and/or modify
   7# it under the terms of the GNU General Public License as published by
   8# the Free Software Foundation, either version 2 of the License, or
   9# (at your option) any later version.
  10#
  11# This program is distributed in the hope that it will be useful,
  12# but WITHOUT ANY WARRANTY; without even the implied warranty of
  13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  14# GNU General Public License for more details.
  15#
  16# You should have received a copy of the GNU General Public License
  17# along with this program.  If not, see http://www.gnu.org/licenses/ .
  18
  19# The semantics of the editor variables are that of invoking
  20# sh -c "$EDITOR \"$@\"" files ...
  21#
  22# If our trash directory contains shell metacharacters, they will be
  23# interpreted if we just set $EDITOR directly, so do a little dance with
  24# environment variables to work around this.
  25#
  26# In particular, quoting isn't enough, as the path may contain the same quote
  27# that we're using.
  28test_set_editor () {
  29        FAKE_EDITOR="$1"
  30        export FAKE_EDITOR
  31        EDITOR='"$FAKE_EDITOR"'
  32        export EDITOR
  33}
  34
  35test_set_index_version () {
  36    GIT_INDEX_VERSION="$1"
  37    export GIT_INDEX_VERSION
  38}
  39
  40test_decode_color () {
  41        awk '
  42                function name(n) {
  43                        if (n == 0) return "RESET";
  44                        if (n == 1) return "BOLD";
  45                        if (n == 7) return "REVERSE";
  46                        if (n == 30) return "BLACK";
  47                        if (n == 31) return "RED";
  48                        if (n == 32) return "GREEN";
  49                        if (n == 33) return "YELLOW";
  50                        if (n == 34) return "BLUE";
  51                        if (n == 35) return "MAGENTA";
  52                        if (n == 36) return "CYAN";
  53                        if (n == 37) return "WHITE";
  54                        if (n == 40) return "BLACK";
  55                        if (n == 41) return "BRED";
  56                        if (n == 42) return "BGREEN";
  57                        if (n == 43) return "BYELLOW";
  58                        if (n == 44) return "BBLUE";
  59                        if (n == 45) return "BMAGENTA";
  60                        if (n == 46) return "BCYAN";
  61                        if (n == 47) return "BWHITE";
  62                }
  63                {
  64                        while (match($0, /\033\[[0-9;]*m/) != 0) {
  65                                printf "%s<", substr($0, 1, RSTART-1);
  66                                codes = substr($0, RSTART+2, RLENGTH-3);
  67                                if (length(codes) == 0)
  68                                        printf "%s", name(0)
  69                                else {
  70                                        n = split(codes, ary, ";");
  71                                        sep = "";
  72                                        for (i = 1; i <= n; i++) {
  73                                                printf "%s%s", sep, name(ary[i]);
  74                                                sep = ";"
  75                                        }
  76                                }
  77                                printf ">";
  78                                $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
  79                        }
  80                        print
  81                }
  82        '
  83}
  84
  85lf_to_nul () {
  86        perl -pe 'y/\012/\000/'
  87}
  88
  89nul_to_q () {
  90        perl -pe 'y/\000/Q/'
  91}
  92
  93q_to_nul () {
  94        perl -pe 'y/Q/\000/'
  95}
  96
  97q_to_cr () {
  98        tr Q '\015'
  99}
 100
 101q_to_tab () {
 102        tr Q '\011'
 103}
 104
 105qz_to_tab_space () {
 106        tr QZ '\011\040'
 107}
 108
 109append_cr () {
 110        sed -e 's/$/Q/' | tr Q '\015'
 111}
 112
 113remove_cr () {
 114        tr '\015' Q | sed -e 's/Q$//'
 115}
 116
 117# In some bourne shell implementations, the "unset" builtin returns
 118# nonzero status when a variable to be unset was not set in the first
 119# place.
 120#
 121# Use sane_unset when that should not be considered an error.
 122
 123sane_unset () {
 124        unset "$@"
 125        return 0
 126}
 127
 128test_tick () {
 129        if test -z "${test_tick+set}"
 130        then
 131                test_tick=1112911993
 132        else
 133                test_tick=$(($test_tick + 60))
 134        fi
 135        GIT_COMMITTER_DATE="$test_tick -0700"
 136        GIT_AUTHOR_DATE="$test_tick -0700"
 137        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 138}
 139
 140# Stop execution and start a shell. This is useful for debugging tests.
 141#
 142# Be sure to remove all invocations of this command before submitting.
 143
 144test_pause () {
 145        "$SHELL_PATH" <&6 >&5 2>&7
 146}
 147
 148# Wrap git with a debugger. Adding this to a command can make it easier
 149# to understand what is going on in a failing test.
 150#
 151# Examples:
 152#     debug git checkout master
 153#     debug --debugger=nemiver git $ARGS
 154#     debug -d "valgrind --tool=memcheck --track-origins=yes" git $ARGS
 155debug () {
 156        case "$1" in
 157        -d)
 158                GIT_DEBUGGER="$2" &&
 159                shift 2
 160                ;;
 161        --debugger=*)
 162                GIT_DEBUGGER="${1#*=}" &&
 163                shift 1
 164                ;;
 165        *)
 166                GIT_DEBUGGER=1
 167                ;;
 168        esac &&
 169        GIT_DEBUGGER="${GIT_DEBUGGER}" "$@" <&6 >&5 2>&7
 170}
 171
 172# Call test_commit with the arguments
 173# [-C <directory>] <message> [<file> [<contents> [<tag>]]]"
 174#
 175# This will commit a file with the given contents and the given commit
 176# message, and tag the resulting commit with the given tag name.
 177#
 178# <file>, <contents>, and <tag> all default to <message>.
 179#
 180# If the first argument is "-C", the second argument is used as a path for
 181# the git invocations.
 182
 183test_commit () {
 184        notick= &&
 185        signoff= &&
 186        indir= &&
 187        while test $# != 0
 188        do
 189                case "$1" in
 190                --notick)
 191                        notick=yes
 192                        ;;
 193                --signoff)
 194                        signoff="$1"
 195                        ;;
 196                -C)
 197                        indir="$2"
 198                        shift
 199                        ;;
 200                *)
 201                        break
 202                        ;;
 203                esac
 204                shift
 205        done &&
 206        indir=${indir:+"$indir"/} &&
 207        file=${2:-"$1.t"} &&
 208        echo "${3-$1}" > "$indir$file" &&
 209        git ${indir:+ -C "$indir"} add "$file" &&
 210        if test -z "$notick"
 211        then
 212                test_tick
 213        fi &&
 214        git ${indir:+ -C "$indir"} commit $signoff -m "$1" &&
 215        git ${indir:+ -C "$indir"} tag "${4:-$1}"
 216}
 217
 218# Call test_merge with the arguments "<message> <commit>", where <commit>
 219# can be a tag pointing to the commit-to-merge.
 220
 221test_merge () {
 222        test_tick &&
 223        git merge -m "$1" "$2" &&
 224        git tag "$1"
 225}
 226
 227# This function helps systems where core.filemode=false is set.
 228# Use it instead of plain 'chmod +x' to set or unset the executable bit
 229# of a file in the working directory and add it to the index.
 230
 231test_chmod () {
 232        chmod "$@" &&
 233        git update-index --add "--chmod=$@"
 234}
 235
 236# Get the modebits from a file.
 237test_modebits () {
 238        ls -l "$1" | sed -e 's|^\(..........\).*|\1|'
 239}
 240
 241# Unset a configuration variable, but don't fail if it doesn't exist.
 242test_unconfig () {
 243        config_dir=
 244        if test "$1" = -C
 245        then
 246                shift
 247                config_dir=$1
 248                shift
 249        fi
 250        git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
 251        config_status=$?
 252        case "$config_status" in
 253        5) # ok, nothing to unset
 254                config_status=0
 255                ;;
 256        esac
 257        return $config_status
 258}
 259
 260# Set git config, automatically unsetting it after the test is over.
 261test_config () {
 262        config_dir=
 263        if test "$1" = -C
 264        then
 265                shift
 266                config_dir=$1
 267                shift
 268        fi
 269        test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
 270        git ${config_dir:+-C "$config_dir"} config "$@"
 271}
 272
 273test_config_global () {
 274        test_when_finished "test_unconfig --global '$1'" &&
 275        git config --global "$@"
 276}
 277
 278write_script () {
 279        {
 280                echo "#!${2-"$SHELL_PATH"}" &&
 281                cat
 282        } >"$1" &&
 283        chmod +x "$1"
 284}
 285
 286# Use test_set_prereq to tell that a particular prerequisite is available.
 287# The prerequisite can later be checked for in two ways:
 288#
 289# - Explicitly using test_have_prereq.
 290#
 291# - Implicitly by specifying the prerequisite tag in the calls to
 292#   test_expect_{success,failure,code}.
 293#
 294# The single parameter is the prerequisite tag (a simple word, in all
 295# capital letters by convention).
 296
 297test_unset_prereq () {
 298        ! test_have_prereq "$1" ||
 299        satisfied_prereq="${satisfied_prereq% $1 *} ${satisfied_prereq#* $1 }"
 300}
 301
 302test_set_prereq () {
 303        case "$1" in
 304        !*)
 305                test_unset_prereq "${1#!}"
 306                ;;
 307        *)
 308                satisfied_prereq="$satisfied_prereq$1 "
 309                ;;
 310        esac
 311}
 312satisfied_prereq=" "
 313lazily_testable_prereq= lazily_tested_prereq=
 314
 315# Usage: test_lazy_prereq PREREQ 'script'
 316test_lazy_prereq () {
 317        lazily_testable_prereq="$lazily_testable_prereq$1 "
 318        eval test_prereq_lazily_$1=\$2
 319}
 320
 321test_run_lazy_prereq_ () {
 322        script='
 323mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
 324(
 325        cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
 326)'
 327        say >&3 "checking prerequisite: $1"
 328        say >&3 "$script"
 329        test_eval_ "$script"
 330        eval_ret=$?
 331        rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
 332        if test "$eval_ret" = 0; then
 333                say >&3 "prerequisite $1 ok"
 334        else
 335                say >&3 "prerequisite $1 not satisfied"
 336        fi
 337        return $eval_ret
 338}
 339
 340test_have_prereq () {
 341        # prerequisites can be concatenated with ','
 342        save_IFS=$IFS
 343        IFS=,
 344        set -- $*
 345        IFS=$save_IFS
 346
 347        total_prereq=0
 348        ok_prereq=0
 349        missing_prereq=
 350
 351        for prerequisite
 352        do
 353                case "$prerequisite" in
 354                !*)
 355                        negative_prereq=t
 356                        prerequisite=${prerequisite#!}
 357                        ;;
 358                *)
 359                        negative_prereq=
 360                esac
 361
 362                case " $lazily_tested_prereq " in
 363                *" $prerequisite "*)
 364                        ;;
 365                *)
 366                        case " $lazily_testable_prereq " in
 367                        *" $prerequisite "*)
 368                                eval "script=\$test_prereq_lazily_$prerequisite" &&
 369                                if test_run_lazy_prereq_ "$prerequisite" "$script"
 370                                then
 371                                        test_set_prereq $prerequisite
 372                                fi
 373                                lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
 374                        esac
 375                        ;;
 376                esac
 377
 378                total_prereq=$(($total_prereq + 1))
 379                case "$satisfied_prereq" in
 380                *" $prerequisite "*)
 381                        satisfied_this_prereq=t
 382                        ;;
 383                *)
 384                        satisfied_this_prereq=
 385                esac
 386
 387                case "$satisfied_this_prereq,$negative_prereq" in
 388                t,|,t)
 389                        ok_prereq=$(($ok_prereq + 1))
 390                        ;;
 391                *)
 392                        # Keep a list of missing prerequisites; restore
 393                        # the negative marker if necessary.
 394                        prerequisite=${negative_prereq:+!}$prerequisite
 395                        if test -z "$missing_prereq"
 396                        then
 397                                missing_prereq=$prerequisite
 398                        else
 399                                missing_prereq="$prerequisite,$missing_prereq"
 400                        fi
 401                esac
 402        done
 403
 404        test $total_prereq = $ok_prereq
 405}
 406
 407test_declared_prereq () {
 408        case ",$test_prereq," in
 409        *,$1,*)
 410                return 0
 411                ;;
 412        esac
 413        return 1
 414}
 415
 416test_verify_prereq () {
 417        test -z "$test_prereq" ||
 418        expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
 419        error "bug in the test script: '$test_prereq' does not look like a prereq"
 420}
 421
 422test_expect_failure () {
 423        test_start_
 424        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 425        test "$#" = 2 ||
 426        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 427        test_verify_prereq
 428        export test_prereq
 429        if ! test_skip "$@"
 430        then
 431                say >&3 "checking known breakage: $2"
 432                if test_run_ "$2" expecting_failure
 433                then
 434                        test_known_broken_ok_ "$1"
 435                else
 436                        test_known_broken_failure_ "$1"
 437                fi
 438        fi
 439        test_finish_
 440}
 441
 442test_expect_success () {
 443        test_start_
 444        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 445        test "$#" = 2 ||
 446        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 447        test_verify_prereq
 448        export test_prereq
 449        if ! test_skip "$@"
 450        then
 451                say >&3 "expecting success: $2"
 452                if test_run_ "$2"
 453                then
 454                        test_ok_ "$1"
 455                else
 456                        test_failure_ "$@"
 457                fi
 458        fi
 459        test_finish_
 460}
 461
 462# test_external runs external test scripts that provide continuous
 463# test output about their progress, and succeeds/fails on
 464# zero/non-zero exit code.  It outputs the test output on stdout even
 465# in non-verbose mode, and announces the external script with "# run
 466# <n>: ..." before running it.  When providing relative paths, keep in
 467# mind that all scripts run in "trash directory".
 468# Usage: test_external description command arguments...
 469# Example: test_external 'Perl API' perl ../path/to/test.pl
 470test_external () {
 471        test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
 472        test "$#" = 3 ||
 473        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 474        descr="$1"
 475        shift
 476        test_verify_prereq
 477        export test_prereq
 478        if ! test_skip "$descr" "$@"
 479        then
 480                # Announce the script to reduce confusion about the
 481                # test output that follows.
 482                say_color "" "# run $test_count: $descr ($*)"
 483                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 484                # to be able to use them in script
 485                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 486                # Run command; redirect its stderr to &4 as in
 487                # test_run_, but keep its stdout on our stdout even in
 488                # non-verbose mode.
 489                "$@" 2>&4
 490                if test "$?" = 0
 491                then
 492                        if test $test_external_has_tap -eq 0; then
 493                                test_ok_ "$descr"
 494                        else
 495                                say_color "" "# test_external test $descr was ok"
 496                                test_success=$(($test_success + 1))
 497                        fi
 498                else
 499                        if test $test_external_has_tap -eq 0; then
 500                                test_failure_ "$descr" "$@"
 501                        else
 502                                say_color error "# test_external test $descr failed: $@"
 503                                test_failure=$(($test_failure + 1))
 504                        fi
 505                fi
 506        fi
 507}
 508
 509# Like test_external, but in addition tests that the command generated
 510# no output on stderr.
 511test_external_without_stderr () {
 512        # The temporary file has no (and must have no) security
 513        # implications.
 514        tmp=${TMPDIR:-/tmp}
 515        stderr="$tmp/git-external-stderr.$$.tmp"
 516        test_external "$@" 4> "$stderr"
 517        test -f "$stderr" || error "Internal error: $stderr disappeared."
 518        descr="no stderr: $1"
 519        shift
 520        say >&3 "# expecting no stderr from previous command"
 521        if test ! -s "$stderr"
 522        then
 523                rm "$stderr"
 524
 525                if test $test_external_has_tap -eq 0; then
 526                        test_ok_ "$descr"
 527                else
 528                        say_color "" "# test_external_without_stderr test $descr was ok"
 529                        test_success=$(($test_success + 1))
 530                fi
 531        else
 532                if test "$verbose" = t
 533                then
 534                        output=$(echo; echo "# Stderr is:"; cat "$stderr")
 535                else
 536                        output=
 537                fi
 538                # rm first in case test_failure exits.
 539                rm "$stderr"
 540                if test $test_external_has_tap -eq 0; then
 541                        test_failure_ "$descr" "$@" "$output"
 542                else
 543                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 544                        test_failure=$(($test_failure + 1))
 545                fi
 546        fi
 547}
 548
 549# debugging-friendly alternatives to "test [-f|-d|-e]"
 550# The commands test the existence or non-existence of $1. $2 can be
 551# given to provide a more precise diagnosis.
 552test_path_is_file () {
 553        if ! test -f "$1"
 554        then
 555                echo "File $1 doesn't exist. $2"
 556                false
 557        fi
 558}
 559
 560test_path_is_dir () {
 561        if ! test -d "$1"
 562        then
 563                echo "Directory $1 doesn't exist. $2"
 564                false
 565        fi
 566}
 567
 568# Check if the directory exists and is empty as expected, barf otherwise.
 569test_dir_is_empty () {
 570        test_path_is_dir "$1" &&
 571        if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
 572        then
 573                echo "Directory '$1' is not empty, it contains:"
 574                ls -la "$1"
 575                return 1
 576        fi
 577}
 578
 579test_path_is_missing () {
 580        if test -e "$1"
 581        then
 582                echo "Path exists:"
 583                ls -ld "$1"
 584                if test $# -ge 1
 585                then
 586                        echo "$*"
 587                fi
 588                false
 589        fi
 590}
 591
 592# test_line_count checks that a file has the number of lines it
 593# ought to. For example:
 594#
 595#       test_expect_success 'produce exactly one line of output' '
 596#               do something >output &&
 597#               test_line_count = 1 output
 598#       '
 599#
 600# is like "test $(wc -l <output) = 1" except that it passes the
 601# output through when the number of lines is wrong.
 602
 603test_line_count () {
 604        if test $# != 3
 605        then
 606                error "bug in the test script: not 3 parameters to test_line_count"
 607        elif ! test $(wc -l <"$3") "$1" "$2"
 608        then
 609                echo "test_line_count: line count for $3 !$1 $2"
 610                cat "$3"
 611                return 1
 612        fi
 613}
 614
 615# Returns success if a comma separated string of keywords ($1) contains a
 616# given keyword ($2).
 617# Examples:
 618# `list_contains "foo,bar" bar` returns 0
 619# `list_contains "foo" bar` returns 1
 620
 621list_contains () {
 622        case ",$1," in
 623        *,$2,*)
 624                return 0
 625                ;;
 626        esac
 627        return 1
 628}
 629
 630# This is not among top-level (test_expect_success | test_expect_failure)
 631# but is a prefix that can be used in the test script, like:
 632#
 633#       test_expect_success 'complain and die' '
 634#           do something &&
 635#           do something else &&
 636#           test_must_fail git checkout ../outerspace
 637#       '
 638#
 639# Writing this as "! git checkout ../outerspace" is wrong, because
 640# the failure could be due to a segv.  We want a controlled failure.
 641#
 642# Accepts the following options:
 643#
 644#   ok=<signal-name>[,<...>]:
 645#     Don't treat an exit caused by the given signal as error.
 646#     Multiple signals can be specified as a comma separated list.
 647#     Currently recognized signal names are: sigpipe, success.
 648#     (Don't use 'success', use 'test_might_fail' instead.)
 649
 650test_must_fail () {
 651        case "$1" in
 652        ok=*)
 653                _test_ok=${1#ok=}
 654                shift
 655                ;;
 656        *)
 657                _test_ok=
 658                ;;
 659        esac
 660        "$@" 2>&7
 661        exit_code=$?
 662        if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
 663        then
 664                echo >&4 "test_must_fail: command succeeded: $*"
 665                return 1
 666        elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
 667        then
 668                return 0
 669        elif test $exit_code -gt 129 && test $exit_code -le 192
 670        then
 671                echo >&4 "test_must_fail: died by signal $(($exit_code - 128)): $*"
 672                return 1
 673        elif test $exit_code -eq 127
 674        then
 675                echo >&4 "test_must_fail: command not found: $*"
 676                return 1
 677        elif test $exit_code -eq 126
 678        then
 679                echo >&4 "test_must_fail: valgrind error: $*"
 680                return 1
 681        fi
 682        return 0
 683} 7>&2 2>&4
 684
 685# Similar to test_must_fail, but tolerates success, too.  This is
 686# meant to be used in contexts like:
 687#
 688#       test_expect_success 'some command works without configuration' '
 689#               test_might_fail git config --unset all.configuration &&
 690#               do something
 691#       '
 692#
 693# Writing "git config --unset all.configuration || :" would be wrong,
 694# because we want to notice if it fails due to segv.
 695#
 696# Accepts the same options as test_must_fail.
 697
 698test_might_fail () {
 699        test_must_fail ok=success "$@" 2>&7
 700} 7>&2 2>&4
 701
 702# Similar to test_must_fail and test_might_fail, but check that a
 703# given command exited with a given exit code. Meant to be used as:
 704#
 705#       test_expect_success 'Merge with d/f conflicts' '
 706#               test_expect_code 1 git merge "merge msg" B master
 707#       '
 708
 709test_expect_code () {
 710        want_code=$1
 711        shift
 712        "$@" 2>&7
 713        exit_code=$?
 714        if test $exit_code = $want_code
 715        then
 716                return 0
 717        fi
 718
 719        echo >&4 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
 720        return 1
 721} 7>&2 2>&4
 722
 723# test_cmp is a helper function to compare actual and expected output.
 724# You can use it like:
 725#
 726#       test_expect_success 'foo works' '
 727#               echo expected >expected &&
 728#               foo >actual &&
 729#               test_cmp expected actual
 730#       '
 731#
 732# This could be written as either "cmp" or "diff -u", but:
 733# - cmp's output is not nearly as easy to read as diff -u
 734# - not all diff versions understand "-u"
 735
 736test_cmp() {
 737        $GIT_TEST_CMP "$@"
 738}
 739
 740# test_cmp_bin - helper to compare binary files
 741
 742test_cmp_bin() {
 743        cmp "$@"
 744}
 745
 746# Use this instead of test_cmp to compare files that contain expected and
 747# actual output from git commands that can be translated.  When running
 748# under GETTEXT_POISON this pretends that the command produced expected
 749# results.
 750test_i18ncmp () {
 751        test -n "$GETTEXT_POISON" || test_cmp "$@"
 752}
 753
 754# Use this instead of "grep expected-string actual" to see if the
 755# output from a git command that can be translated either contains an
 756# expected string, or does not contain an unwanted one.  When running
 757# under GETTEXT_POISON this pretends that the command produced expected
 758# results.
 759test_i18ngrep () {
 760        eval "last_arg=\${$#}"
 761
 762        test -f "$last_arg" ||
 763        error "bug in the test script: test_i18ngrep requires a file" \
 764              "to read as the last parameter"
 765
 766        if test $# -lt 2 ||
 767           { test "x!" = "x$1" && test $# -lt 3 ; }
 768        then
 769                error "bug in the test script: too few parameters to test_i18ngrep"
 770        fi
 771
 772        if test -n "$GETTEXT_POISON"
 773        then
 774                # pretend success
 775                return 0
 776        fi
 777
 778        if test "x!" = "x$1"
 779        then
 780                shift
 781                ! grep "$@" && return 0
 782
 783                echo >&4 "error: '! grep $@' did find a match in:"
 784        else
 785                grep "$@" && return 0
 786
 787                echo >&4 "error: 'grep $@' didn't find a match in:"
 788        fi
 789
 790        if test -s "$last_arg"
 791        then
 792                cat >&4 "$last_arg"
 793        else
 794                echo >&4 "<File '$last_arg' is empty>"
 795        fi
 796
 797        return 1
 798}
 799
 800# Call any command "$@" but be more verbose about its
 801# failure. This is handy for commands like "test" which do
 802# not output anything when they fail.
 803verbose () {
 804        "$@" && return 0
 805        echo >&4 "command failed: $(git rev-parse --sq-quote "$@")"
 806        return 1
 807}
 808
 809# Check if the file expected to be empty is indeed empty, and barfs
 810# otherwise.
 811
 812test_must_be_empty () {
 813        test_path_is_file "$1" &&
 814        if test -s "$1"
 815        then
 816                echo "'$1' is not empty, it contains:"
 817                cat "$1"
 818                return 1
 819        fi
 820}
 821
 822# Tests that its two parameters refer to the same revision
 823test_cmp_rev () {
 824        git rev-parse --verify "$1" >expect.rev &&
 825        git rev-parse --verify "$2" >actual.rev &&
 826        test_cmp expect.rev actual.rev
 827}
 828
 829# Print a sequence of integers in increasing order, either with
 830# two arguments (start and end):
 831#
 832#     test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
 833#
 834# or with one argument (end), in which case it starts counting
 835# from 1.
 836
 837test_seq () {
 838        case $# in
 839        1)      set 1 "$@" ;;
 840        2)      ;;
 841        *)      error "bug in the test script: not 1 or 2 parameters to test_seq" ;;
 842        esac
 843        test_seq_counter__=$1
 844        while test "$test_seq_counter__" -le "$2"
 845        do
 846                echo "$test_seq_counter__"
 847                test_seq_counter__=$(( $test_seq_counter__ + 1 ))
 848        done
 849}
 850
 851# This function can be used to schedule some commands to be run
 852# unconditionally at the end of the test to restore sanity:
 853#
 854#       test_expect_success 'test core.capslock' '
 855#               git config core.capslock true &&
 856#               test_when_finished "git config --unset core.capslock" &&
 857#               hello world
 858#       '
 859#
 860# That would be roughly equivalent to
 861#
 862#       test_expect_success 'test core.capslock' '
 863#               git config core.capslock true &&
 864#               hello world
 865#               git config --unset core.capslock
 866#       '
 867#
 868# except that the greeting and config --unset must both succeed for
 869# the test to pass.
 870#
 871# Note that under --immediate mode, no clean-up is done to help diagnose
 872# what went wrong.
 873
 874test_when_finished () {
 875        # We cannot detect when we are in a subshell in general, but by
 876        # doing so on Bash is better than nothing (the test will
 877        # silently pass on other shells).
 878        test "${BASH_SUBSHELL-0}" = 0 ||
 879        error "bug in test script: test_when_finished does nothing in a subshell"
 880        test_cleanup="{ $*
 881                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 882}
 883
 884# Most tests can use the created repository, but some may need to create more.
 885# Usage: test_create_repo <directory>
 886test_create_repo () {
 887        test "$#" = 1 ||
 888        error "bug in the test script: not 1 parameter to test-create-repo"
 889        repo="$1"
 890        mkdir -p "$repo"
 891        (
 892                cd "$repo" || error "Cannot setup test environment"
 893                "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
 894                error "cannot run git init -- have you built things yet?"
 895                mv .git/hooks .git/hooks-disabled
 896        ) || exit
 897}
 898
 899# This function helps on symlink challenged file systems when it is not
 900# important that the file system entry is a symbolic link.
 901# Use test_ln_s_add instead of "ln -s x y && git add y" to add a
 902# symbolic link entry y to the index.
 903
 904test_ln_s_add () {
 905        if test_have_prereq SYMLINKS
 906        then
 907                ln -s "$1" "$2" &&
 908                git update-index --add "$2"
 909        else
 910                printf '%s' "$1" >"$2" &&
 911                ln_s_obj=$(git hash-object -w "$2") &&
 912                git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
 913                # pick up stat info from the file
 914                git update-index "$2"
 915        fi
 916}
 917
 918# This function writes out its parameters, one per line
 919test_write_lines () {
 920        printf "%s\n" "$@"
 921}
 922
 923perl () {
 924        command "$PERL_PATH" "$@" 2>&7
 925} 7>&2 2>&4
 926
 927# Is the value one of the various ways to spell a boolean true/false?
 928test_normalize_bool () {
 929        git -c magic.variable="$1" config --bool magic.variable 2>/dev/null
 930}
 931
 932# Given a variable $1, normalize the value of it to one of "true",
 933# "false", or "auto" and store the result to it.
 934#
 935#     test_tristate GIT_TEST_HTTPD
 936#
 937# A variable set to an empty string is set to 'false'.
 938# A variable set to 'false' or 'auto' keeps its value.
 939# Anything else is set to 'true'.
 940# An unset variable defaults to 'auto'.
 941#
 942# The last rule is to allow people to set the variable to an empty
 943# string and export it to decline testing the particular feature
 944# for versions both before and after this change.  We used to treat
 945# both unset and empty variable as a signal for "do not test" and
 946# took any non-empty string as "please test".
 947
 948test_tristate () {
 949        if eval "test x\"\${$1+isset}\" = xisset"
 950        then
 951                # explicitly set
 952                eval "
 953                        case \"\$$1\" in
 954                        '')     $1=false ;;
 955                        auto)   ;;
 956                        *)      $1=\$(test_normalize_bool \$$1 || echo true) ;;
 957                        esac
 958                "
 959        else
 960                eval "$1=auto"
 961        fi
 962}
 963
 964# Exit the test suite, either by skipping all remaining tests or by
 965# exiting with an error. If "$1" is "auto", we then we assume we were
 966# opportunistically trying to set up some tests and we skip. If it is
 967# "true", then we report a failure.
 968#
 969# The error/skip message should be given by $2.
 970#
 971test_skip_or_die () {
 972        case "$1" in
 973        auto)
 974                skip_all=$2
 975                test_done
 976                ;;
 977        true)
 978                error "$2"
 979                ;;
 980        *)
 981                error "BUG: test tristate is '$1' (real error: $2)"
 982        esac
 983}
 984
 985# The following mingw_* functions obey POSIX shell syntax, but are actually
 986# bash scripts, and are meant to be used only with bash on Windows.
 987
 988# A test_cmp function that treats LF and CRLF equal and avoids to fork
 989# diff when possible.
 990mingw_test_cmp () {
 991        # Read text into shell variables and compare them. If the results
 992        # are different, use regular diff to report the difference.
 993        local test_cmp_a= test_cmp_b=
 994
 995        # When text came from stdin (one argument is '-') we must feed it
 996        # to diff.
 997        local stdin_for_diff=
 998
 999        # Since it is difficult to detect the difference between an
1000        # empty input file and a failure to read the files, we go straight
1001        # to diff if one of the inputs is empty.
1002        if test -s "$1" && test -s "$2"
1003        then
1004                # regular case: both files non-empty
1005                mingw_read_file_strip_cr_ test_cmp_a <"$1"
1006                mingw_read_file_strip_cr_ test_cmp_b <"$2"
1007        elif test -s "$1" && test "$2" = -
1008        then
1009                # read 2nd file from stdin
1010                mingw_read_file_strip_cr_ test_cmp_a <"$1"
1011                mingw_read_file_strip_cr_ test_cmp_b
1012                stdin_for_diff='<<<"$test_cmp_b"'
1013        elif test "$1" = - && test -s "$2"
1014        then
1015                # read 1st file from stdin
1016                mingw_read_file_strip_cr_ test_cmp_a
1017                mingw_read_file_strip_cr_ test_cmp_b <"$2"
1018                stdin_for_diff='<<<"$test_cmp_a"'
1019        fi
1020        test -n "$test_cmp_a" &&
1021        test -n "$test_cmp_b" &&
1022        test "$test_cmp_a" = "$test_cmp_b" ||
1023        eval "diff -u \"\$@\" $stdin_for_diff"
1024}
1025
1026# $1 is the name of the shell variable to fill in
1027mingw_read_file_strip_cr_ () {
1028        # Read line-wise using LF as the line separator
1029        # and use IFS to strip CR.
1030        local line
1031        while :
1032        do
1033                if IFS=$'\r' read -r -d $'\n' line
1034                then
1035                        # good
1036                        line=$line$'\n'
1037                else
1038                        # we get here at EOF, but also if the last line
1039                        # was not terminated by LF; in the latter case,
1040                        # some text was read
1041                        if test -z "$line"
1042                        then
1043                                # EOF, really
1044                                break
1045                        fi
1046                fi
1047                eval "$1=\$$1\$line"
1048        done
1049}
1050
1051# Like "env FOO=BAR some-program", but run inside a subshell, which means
1052# it also works for shell functions (though those functions cannot impact
1053# the environment outside of the test_env invocation).
1054test_env () {
1055        (
1056                while test $# -gt 0
1057                do
1058                        case "$1" in
1059                        *=*)
1060                                eval "${1%%=*}=\${1#*=}"
1061                                eval "export ${1%%=*}"
1062                                shift
1063                                ;;
1064                        *)
1065                                "$@" 2>&7
1066                                exit
1067                                ;;
1068                        esac
1069                done
1070        )
1071} 7>&2 2>&4
1072
1073# Returns true if the numeric exit code in "$2" represents the expected signal
1074# in "$1". Signals should be given numerically.
1075test_match_signal () {
1076        if test "$2" = "$((128 + $1))"
1077        then
1078                # POSIX
1079                return 0
1080        elif test "$2" = "$((256 + $1))"
1081        then
1082                # ksh
1083                return 0
1084        fi
1085        return 1
1086}
1087
1088# Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
1089test_copy_bytes () {
1090        perl -e '
1091                my $len = $ARGV[1];
1092                while ($len > 0) {
1093                        my $s;
1094                        my $nread = sysread(STDIN, $s, $len);
1095                        die "cannot read: $!" unless defined($nread);
1096                        last unless $nread;
1097                        print $s;
1098                        $len -= $nread;
1099                }
1100        ' - "$1"
1101}
1102
1103# run "$@" inside a non-git directory
1104nongit () {
1105        test -d non-repo ||
1106        mkdir non-repo ||
1107        return 1
1108
1109        (
1110                GIT_CEILING_DIRECTORIES=$(pwd) &&
1111                export GIT_CEILING_DIRECTORIES &&
1112                cd non-repo &&
1113                "$@" 2>&7
1114        )
1115} 7>&2 2>&4
1116
1117# convert stdin to pktline representation; note that empty input becomes an
1118# empty packet, not a flush packet (for that you can just print 0000 yourself).
1119packetize() {
1120        cat >packetize.tmp &&
1121        len=$(wc -c <packetize.tmp) &&
1122        printf '%04x%s' "$(($len + 4))" &&
1123        cat packetize.tmp &&
1124        rm -f packetize.tmp
1125}
1126
1127# Parse the input as a series of pktlines, writing the result to stdout.
1128# Sideband markers are removed automatically, and the output is routed to
1129# stderr if appropriate.
1130#
1131# NUL bytes are converted to "\\0" for ease of parsing with text tools.
1132depacketize () {
1133        perl -e '
1134                while (read(STDIN, $len, 4) == 4) {
1135                        if ($len eq "0000") {
1136                                print "FLUSH\n";
1137                        } else {
1138                                read(STDIN, $buf, hex($len) - 4);
1139                                $buf =~ s/\0/\\0/g;
1140                                if ($buf =~ s/^[\x2\x3]//) {
1141                                        print STDERR $buf;
1142                                } else {
1143                                        $buf =~ s/^\x1//;
1144                                        print $buf;
1145                                }
1146                        }
1147                }
1148        '
1149}